# This file is part of the graph-includes package
#
# (c) 2005 Yann Dirson <ydirson@altern.org>
# Distributed under version 2 of the GNU GPL.

package graphincludes::project::default;
use graphincludes::project;
our @ISA = qw(graphincludes::project);

sub new {
    my $class = shift;
    my $self;

    $self  = $class->SUPER::new(@_);

    bless ($self, $class);
    return $self;
}

#sub insert {
#  my $self = shift;
#  my ($file, $subtree) = @_;
#
#  if ($file =~ m|([^/]+)/(.+)$|) {
#    my ($dir, $rest) = ($1, $2);
#    #print "dir1 = $dir, rest = $rest\n";
#
#    if (defined $subtree->{$dir} and $subtree->{$dir} == 1) {
#      die "inconsistent input - $dir already exists as a file";
#    }
#
#    $subtree->{$dir} = {} unless defined $subtree->{$dir};
#    $self->insert ($rest, $subtree->{$dir});
#  } else {
#    if (defined $subtree->{$file}) {
#      die "inconsistent input - $file already exists" if $main::showallfiles;
#    }
#    $subtree->{$file} = 1;
#  }
#  return $subtree;
#}

sub filelabel {
  my $self = shift;
  my ($file,$level) = @_;
  $level = $main::minshow unless defined $level;

  if ($level == 0) {
    return $file;
  } elsif ($level == 1) {
    $file =~ s/\.[^.]*$//;
    return $file;
  } elsif ($level == 2) {
    if ($file =~ m!(.*)/.*!) {
      return $1;
    }
  }
  return undef;
}

sub defaultcolors {
  return ();
}

sub getdeps {
    my $self = shift;
    my %deps;

    sub fullpath {
	my ($dstpath, $strip, $srcpath) = @_;
	join ('/', @$srcpath[0..($#$srcpath-$strip)], @$dstpath);
    }

    while (<>) {
	my @srcpath = split (m|/|, $ARGV);
	if (m/^\s*#\s*include\s*"(.*)"/) {
	    my @dstpath = split (m|/|, $1);
	    my $strip = 1;
	    while ($dstpath[0] eq '..') { $strip++; shift @dstpath; }
	    while ($#srcpath >= $strip and
		   !defined $self->{NODEIDS}->{$self->filelabel(fullpath(\@dstpath,$strip,\@srcpath))})
	    { $strip++; }
	    my $dstfile = fullpath(\@dstpath,$strip,\@srcpath);
	    if (grep { $_ eq $dstfile } @{$self->{FILES}}) {
		push (@{$deps{$self->{NODEIDS}->{$self->filelabel($ARGV)}}},
		      $self->{NODEIDS}->{$self->filelabel($dstfile)});
	    } else {
		print STDERR "ERROR: unknown file $dstfile referenced by $ARGV\n" if $main::verbose >= 2;
	    }
	} elsif (m/^\s*#\s*include\s*<(.*)>/) {
		 print STDERR "Ignoring <$1> for now ($ARGV)\n" if $main::verbose >= 2;
	     }
    }
    return \%deps;
}

1;
