# This file is part of the graph-includes package
#
# (c) 2005 Yann Dirson <ydirson@altern.org>
# Distributed under version 2 of the GNU GPL.

package graphincludes::project::uniqueincludes;
use graphincludes::project::default;
our @ISA = qw(graphincludes::project::default);

sub filelabel {
  my $self = shift;
  my ($file) = @_;
  $file =~ s!(?:.*/)?([^/]*)\.[^./]*$!$1! unless $main::showallfiles;
  return $file;
}

sub getdeps {
    my $self = shift;
    my %deps;

    while (<>) {
	if (m!^\s*#\s*include\s*[<"](?:.*/)?([^/]+)(\.[^.]+)[>"]!) {
	    my $dstfile = $1;
	    if (grep { $self->filelabel($_) eq $dstfile } @{$self->{FILES}}) {
		push (@{$deps{$self->{NODEIDS}->{$self->filelabel($ARGV)}}},
		      $self->{NODEIDS}->{$self->filelabel($dstfile)});
	    } else {
		print STDERR "ERROR: unknown file $dstfile referenced by $ARGV\n" if $main::verbose >= 2;
	    }
	}
    }
    return \%deps;
}

1;
